//+------------------------------------------------------------------+
//|                                                    ChatModel.mqh |
//|                                 Copyright 2017, Daniele Bignotti |
//|                                           d.bignotti90@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, Daniele Bignotti"
#property link      "d.bignotti90@gmail.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//|#include                                                          |
//+------------------------------------------------------------------+
#include "Core/Subject.mqh"
#include "Core/ObserverList.mqh"
#include <Arrays/ArrayString.mqh>
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CChatModel : public ISubject
  {
private:

   CObserverList     m_forumObserverList;
   CArrayString      m_messages;

public:
                     CChatModel();
                    ~CChatModel();

   void addMessage(string msg) {m_messages.Add(msg); inform();}
   string            getMessages(void);
   virtual void attach(IObserver *forumObserver) {m_forumObserverList.Add(forumObserver); m_forumObserverList.Sort(0);}
   virtual void detach(IObserver *forumObserver) {m_forumObserverList.Delete(m_forumObserverList.Search(forumObserver));}
   virtual void              inform(void);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CChatModel::CChatModel()
  {
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CChatModel::~CChatModel()
  {
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string CChatModel::getMessages(void)
  {
   int length=m_messages.Total();
   string allMessages="";
   for(int i=0; i<length;++i)
     {
      allMessages+=m_messages.At(i);
     }
   return allMessages;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CChatModel::inform(void)
  {
   for(int i=0;i<m_forumObserverList.Total();i++)
     {
      IObserver *puntatore=m_forumObserverList.At(i);
      puntatore.update();
     }
  }
//+------------------------------------------------------------------+
/*import java.util.*;

public class ChatModel implements ChatObservable {
    private Vector messages;

    private Vector forumObserversVector = new java.util.Vector();

    public ChatModel() {
        messages = new Vector();
    }

    public void addMessage(String msg) {
        messages.add(msg);
        inform();
    }

    public String getMessages() {
        int length = messages.size();
        String allMessages = "";
        for (int i = 0; i < length; ++i) {
            allMessages += (String)messages.elementAt(i)+"\n";
        }
        return allMessages;
    }

    public void attach(ChatObserver forumObserver){
            forumObserversVector.addElement(forumObserver);
        }

    public void detach(ChatObserver forumObserver){
            forumObserversVector.removeElement(forumObserver);
        }

    public void inform(){
            java.util.Enumeration enumeration = forumObservers();
            while (enumeration.hasMoreElements()) {
                ((ChatObserver)enumeration.nextElement()).update();
            }
        }

    public Enumeration forumObservers(){
            return ((java.util.Vector) forumObserversVector.clone()).elements();
        }
}
*/